#-*-coding: utf-8-*-
from copy import copy
import decimal
import names
from datetime import date

#TODO
#dodać wartość prowizji

def round(x,r=0):
    return decimal.Decimal(x).quantize(decimal.Decimal(10)**-r,rounding=decimal.ROUND_HALF_UP)

class SubRegister():
    def __init__(self, units=decimal.Decimal(0), price=decimal.Decimal(0), buyprice=decimal.Decimal(0), buydate='', date='', invested=decimal.Decimal(0)):
        #give value
        self.setunits(units)
        self.setprice(price)
        self.setdate(date)
        self.setbuyprice(buyprice)
        self.setbuydate(buydate)
        self.setinvested(invested)
        
    def __str__(self):
        zysk = round(-self.getbuyvalue() + self.getvalue(),2)
        procent = round(zysk/self.getbuyvalue() * decimal.Decimal(100),2)
        zysk_inv = round(-self.invested + self.getvalue(),2)
        procent_inv = round(zysk_inv/self.invested * decimal.Decimal(100),2)
        dt = self.date - self.buydate
        dt = round(dt.days / 365.,3)
        if dt ==0:dt=1
        a = '''Units: %s Invested: %s
Buy --- price: %s, value %s, date: %s
Now --- price: %s, value %s, date: %s
Zysk: [NV-BV]=%s (%s%%) [NV-INV]=%s (%s%%)
dt: %s y         (%s%%)             (%s%%)
''' % (self.units, self.invested, self.buyprice, self.getbuyvalue(), self.buydate, self.price, self.getvalue(), self.date, zysk ,procent, zysk_inv, procent_inv,dt, round(procent/dt,2), round(procent_inv/dt,2))
        return a
        
#data when buying
    def setunits(self, number):
        #number of participation units
        self.units = number
    def setbuydate(self, date):
        #date when units were buy
        self.buydate = date
    def setbuyprice(self, price):
        #unit price when it was bought?
        self.buyprice = price
    def getbuyvalue(self):
        return round(self.units * self.buyprice,2)
    def setinvested(self, value):
        self.invested = value #invested - ile pieniędzy zainwestowane, ważne przy subfunduszach
        
#data for present
    def getvalue(self):
        #actual value of units
        return round(self.units * self.price,2)
    def setprice(self, price):
        #actula unit price
        self.price = price
    def setdate(self, value):
        self.date = value
        
#if subregister will be terminated, then:
    def setselldate(self, date):
        #date when units were sell(if they were)
        self.selldate = date
    def setstatus(self, description):
        self.status = description
#===============================================================================
#===============================================================================
class Register():
    def __init__(self, fundnumber=0):
        self.subreg = []
        self.setprice(decimal.Decimal(0))
        self.setdate('')
        self.setfundnumber(fundnumber)
        
#dane rejestru
    def setfundnumber(self, number):
        self.fundnumber=number
    def settype(self, value):
        '''Sposób wyboru kolejności sprzedaży podrejestrów
HIFO, LIFO, FIFO ...'''
        self.type = value #like HIFO, LIFO, FIFO
    def setprice(self, value):
        '''Aktualna (podana w .date) wycena j.u.'''
        self.price = value
        for i in self.subreg:
            i.setprice(value)
    def setdate(self, value):
        '''Data aktualnej wyceny j.u.'''
        self.date = value
        for i in self.subreg:
            i.setdate(value)
    def getunits(self):
        '''Sumuje liczbę jednostek w poszczególnych podrejestrach'''
        u = decimal.Decimal(0)
        for i in self.subreg:
            u += i.units
        return u
    def getbuyvalue(self):
        '''Sumuje wartość zakupu podrejestrów'''
        v = decimal.Decimal(0)
        for i in self.subreg:
            v += i.getbuyvalue()
        return v
    def getvalue(self):
        '''Podaje aktualną wartość rejestru jako sumę podrejestrów'''
        v = decimal.Decimal(0)
        for i in self.subreg:
            v += i.getvalue()
        return v
    def getinvested(self):
        '''Zwraca wartość zainwestowanych pieniędzy'''
        v = decimal.Decimal(0)
        for i in self.subreg:
            v += i.invested
        return v
    def getfundname(self):
        a = names.Name(self.fundnumber)
        return a.getfundname()
    def getbrandname(self):
        a = names.Name(self.fundnumber)
        return a.getbrandname()
    def getbrandnumber(self):
        fn = self.fundnumber
        if fn == 0:
            return 0
        elif fn > 1000:
            return int(str(fn)[-3:len(str(fn))])
        else:
            return 0
    
#modyfikacja podrejestrów        
    def addsubreg(self, new):
        '''Dodaje podrejestr, należy go wcześniej utworzyć'''
        self.subreg.append(new)
#inne funkcje
    def sellsubreg(self, units):
        '''Funkcja sprzedaje podrejestr. parametry: ilość sprzedawanych j.u.
(units), Funkcja zwraca podrejestry, które sprzedała'''
        if self.getunits() < units: return 'Za dużo jednostek do sprzedania'
        b = [] #zawiera posortowaną listę
        new = [] #zawiera sprzedane podrejestry, które zwróci
        if self.type == 'HIFO' or self.type == 'LIFO':
            for i in range(len(self.subreg)): #domyślne posortowanie wg ceny
                b.append([self.subreg[i].buyprice, i])
            b.sort() #posortowane wg ceny [-1] ma najwyższą cenę i pierwszy wychodzi
            if self.type == 'LIFO': b.reverse()
        elif self.type == 'FIFO':
            for i in range(len(self.subreg)): #posortować wg daty zakupu
                b.append([self.subreg[i].buydate, i])
            b.sort() #[0] jest najstarszy
            if self.type == 'FIFO': b.reverse()
        else:
            return 'Last in first out nie obsługuję'
        i = b[-1][1] #listy są od końca poukładane, zwraca [1]-który podrejestr
        whatdel = []
        while self.subreg[i].units <= units: #pamiętać by zając się modyfikacją invested
            try:
                units = units - self.subreg[i].units
                new.append(copy(self.subreg[i])) #będzie zwracał sprzedany podrejestr
                #usuniemy kiedy indziej self.subreg.pop(i) #usuwamy w całości
                whatdel.append(b[-1][1])
                b.pop(-1)
                i = b[-1][1] #przechodzimy do kolejnego
            except: #tutaj dodać obsługe tylko IndexError
                whatdel.sort()
                whatdel.reverse()
                if self.subreg[i].units < 0.000001: self.subreg[i].setunits(decimal.Decimal(0)) #czyli końcówki
                for i in whatdel:
                    self.subreg.pop(i)
                
                return new
        else: #jeżeli pozostanie w podrejestrze j.u.
            new.append(copy(self.subreg[i]))
            x = round(new[-1].invested * units / new[-1].units,2) #ile kasy z zainwestowanego sprzedano
            y = new[-1].invested - x #ile kasy pozostaje zainwestwane
            new[-1].setinvested(x)#tyczy się invested
            new[-1].setunits(units)
            self.subreg[i].setunits(self.subreg[i].units-units)
            if self.subreg[i].units < 0.000001: self.subreg[i].setunits(decimal.Decimal(0)) #czyli końcówki
            self.subreg[i].setinvested(y)
            whatdel.sort()
            whatdel.reverse()
            for i in whatdel:
                self.subreg.pop(i)
            return new
        
    def __str__(self):
        zysk = round(-self.getbuyvalue() + self.getvalue(),2)
        procent = round(zysk/self.getbuyvalue() * decimal.Decimal(100),2)
        zysk_inv = round(-self.getinvested() + self.getvalue(),2)
        procent_inv = round(zysk_inv/self.getinvested() * decimal.Decimal(100),2)
        dt=self.date-self.subreg[0].buydate
        dt = round(dt.days / 365.,1)
        a = '''Name: %s (%s) Brand: %s Type: %s
Units: %s Price: %s First subreg date: %s (dt:%s y)
Buy Value: %s Invested: %s
Now Value: %s [NV-BV]=%s(%s%%) [NV-INV]=%s(%s%%)
''' % (self.getfundname(), self.fundnumber, self.getbrandname(), self.type, self.getunits(), self.price, self.subreg[0].buydate, dt, self.getbuyvalue(), self.getinvested(), self.getvalue(), zysk, procent, zysk_inv, procent_inv)
        return a
    
    def __getitem__(self, i):
        return self.subreg[i]
        
    def __len__(self):
        return len(self.subreg)
