#-*-coding: utf-8-*-
from urllib import urlopen
from datetime import date
import decimal


#class Validation(UnionInvestment):
#    def setname(self, value):
#        self.name = value
#    def setdate(self, value):
#        self.date = value
#    def setprice(self, value):
#        self.price(value)
#    def setgroup(self, value):
#        self.group = value

class SFILoad():
    def __init__(self):
        self.name = []
        self.price = []
    def load(self):
        y = str(date.today().year)
        m = str(date.today().month)
        if len(m) <2:m='0'+m
        d = str(date.today().day-1)
        if len(d)<2:d='0'+d
        #http://www.mbank.pl/inc/sfi/sfi_do_csv/?sh=0,2,3,4,5,6,7,8,9,10,11&date=2013-12-06&show=all
        a = urlopen('http://www.mbank.pl/inc/sfi/sfi_do_csv/?sh=3,4,5,6,7,8,9,11&date=' + y + '-' + m + '-' + d + '&show=all')
        print 'http://www.mbank.pl/inc/sfi/sfi_do_csv/?sh=3,4,5,6,7,8,9,11&date=' + y + '-' + m + '-' + d + '&show=all'
        t = [] #tablica do wyceny bedzie w postaci [nr_fund,wycena,data]
        
        b = a.next()
        if b[0:10] == '"Notowania': #test czy format pliku sie nie zmienil
            a.next() #pusta linia
            a.next() #naglowek
        else:
            self.name = ["Couldn't find. Source changed"]
            return
        
        b = []
        for line in a:
            b.append(line.split(";"))
        
        for i in b:
            #          Nazwa->Numer           Cena w formacie decimal                               data wyc
            j= self.nametonumber(i[0])
            if j == 0: continue #pozniej wyrzucic
            t.append([self.nametonumber(i[0]),decimal.Decimal(i[2].replace(',','.').replace('"','')),date(int(i[-1][1:5]),int(i[-1][6:8]),int(i[-1][9:11]))])
        return t
            
    def nametonumber(self, text):
        #konwersja skrawka nazwy do numeru
        
        #numery fuduszy w konwencji NFFFF gdzie N numer kolejny dla funduszu
        #FFFF kolejny numer dla towarzystwa (wg tej konw max il tow. 1k)
        #wylapanie kilku slow kluczy
        
        #wyszukanie nazwy towarzystwa
        if text.lower().find('pzu') != -1: #czyli znalzl 001 PZU
            if text.lower().find('energia') != -1:
                return 1001 #PZU Subfundusz Energia Medycyna Ekologia
            elif text.lower().find('polonez') != -1:
                return 2001 #PZU Papierow Dluznych POLONEZ
            elif text.lower().find('wkowy') != -1:
                return 3001 #PZU Subfundusz Gotowkowy
            elif text.lower().find('inwestowania') != -1:
                return 4001 #PZU Subfundusz Bezpiecznego Inwestowania
            elif text.lower().find('rozwini') != -1:
                return 5001 #PZU Subfundusz Akcji Rynkow Rozwinietych
            elif text.lower().find('wschodz') != -1:
                return 6001 #PZU Subfundusz Akcji Rynkow Wschodzacych
            elif text.lower().find('mazurek') != -1:
                return 7001 #PZU Subfundusz Stabilnego Wzrostu MAZUREK
            elif text.lower().find('wnowa') != -1:
                return 8001 #PZU Subfundusz Zrownowazony
            elif text.lower().find('rednich') != -1:
                return 9001 #PZU Subfundusz Akcji Malych i Srednich 
            elif text.lower().find('krakowiak') != -1:
                return 10001 #PZU Subfundusz Akcji KRAKOWIAK
            elif text.lower().find('dywidendowych') != -1:
                return 11001 #PZU Subfundusz Akcji Spolek Dywidendowych
            elif text.lower().find('europa') != -1:
                return 12001 #PZU Subfundusz Akcji Nowa Europa
            else:
                return 1 #inne z nazwa PZU
        elif text.lower().find('pko') != -1: #czyli znalzl 002 PKO
            if text.lower().find('nych plus') != -1:
                return 1002 #PKO Subfundusz Papierow Dluznych Plus
            elif text.lower().find('nych usd') != -1:
                return 2002 #PKO SFIO Sub Papierow Dluznych USD
            elif text.lower().find('ugoterminowych') != -1:
                return 3002 #PKO FIO Obligacji Dlugoterminowych
            elif text.lower().find('ameryka') != -1:
                return 4002 #PKO SFIO Sub Akcji Rynku Amerykanskiego
            elif text.lower().find('obligacji') != -1: #tu uwaga nie oblig dlugo
                if text.lower().find('obligacji d') != -1:
                    return 3002 #PKO FIO Obligacji Dlugoterminowych
                else:
                    return 5002 #PKO FIO Obligacji
            elif text.lower().find('nych euro') != -1:
                return 6002 #PKO SFIO Sub Papierow Dluznych EURO
            elif text.lower().find('fio skarbowy') != -1:
                return 7002 #PKO FIO Skarbowy
            elif text.lower().find('rynku pieni') != -1:
                return 8002 #PKO FIO Rynku Pienieznego
            elif text.lower().find('wzrostu plus') != -1:
                return 9002 #PKO Subfundusz Stabilnego Wzrostu Plus
            elif text.lower().find('pacyfiku') != -1:
                return 10002 #PKO SFIO Sub Akcji Rynku Azji i Pacyfiku
            elif text.lower().find('japo') != -1:
                return 11002 #PKO SFIO Akcji Rynku Japoñskiego
            elif text.lower().find('stabilnego wzrostu') != -1:
                if text.lower().find('wzrostu plus') != -1:
                    return 9002
                else:
                    return 12002 #PKO FIO Stabilnego Wzrostu
            elif text.lower().find('luksusowych') != -1:
                return 13002 #PKO Subfundusz Dobr Luksusowych Globalny
            elif text.lower().find('w wschodz') != -1:
                return 14002 #PKO SFIO Akcji Rynkow Wschodzacych
            elif text.lower().find('ochrony kapi') != -1:
                return 15002 #PKO Ochrony Kapitalu 100
            elif text.lower().find('biotechnologii') != -1:
                return 16002 #PKO Subfundusz Biotechnologii i Innowacji Globalny
            elif text.lower().find('ony plus') != -1:
                return 17002 #PKO Subfundusz Zrownowazony Plus
            elif text.lower().find('nej alokacji') != -1:
                return 18002 #PKO FIO Strategicznej Alokacji
            elif text.lower().find('wnowa') != -1:
                if text.lower().find('ony plus') != -1:
                    return 17002 #
                else:
                    return 19002 #PKO FIO Zrownowazony
            elif text.lower().find('w globalny') != -1:
                return 20002 #PKO Subfundusz Surowcow Globalny
            elif text.lower().find('akcji nowa europa') != -1:
                return 21002 #PKO FIO Akcji Nowa Europa
            elif text.lower().find('akcji plus') != -1:
                return 22002 #PKO Subfundusz Akcji Plus
            elif text.lower().find('akcji ma') != -1:
                if text.lower().find('ek plus') != -1:
                    return 26002 #PKO Subfundusz Akcji Malych i Srednich Spolek Plus
                else:
                    return 23002 #PKO FIO Akcji Malych i Srednich Spolek
            elif text.lower().find('pko fio akcji') != -1:
                if text.lower().find('akcji ma') != -1:
                    return 23002 #
                elif text.lower().find('akcji nowa') != -1:
                    return 21002 #
                else:
                    return 24002 #PKO FIO Akcji
            elif text.lower().find('y i budownic') != -1:
                return 25002 #PKO Subfundusz Infrastruktury i Budownictwa Globalny
            #elif text.lower().find('akcji ma') != -1:
                #return 26002 #PKO Subfundusz Akcji Malych i Srednich Spolek Plus wyzej
            elif text.lower().find('skarbowy plus') != -1:
                return 27002 #PKO Subfundusz Skarbowy Plus
            else:
                return 2 #inne z nazwa pko
        elif text.lower().find('uni') != -1:
            if text.lower().find('dolar pieni') != -1:
                return 1003 #UNIDOLAR PIENIezNY
            elif text.lower().find('obligacje: nowa') != -1:
                return 2003 #UniObligacje: Nowa Europa
            elif text.lower().find('korona obligacje') != -1:
                return 3003 #UniKorona Obligacje
            elif text.lower().find('wibid') != -1:
                return 4003 #UniWIBID Subfundusz SFIO
            elif text.lower().find('korona pieni') != -1:
                return 5003 #UniKorona Pieniezny
            elif text.lower().find('bezpieczna alokacja') != -1:
                return 6003 #UniBezpieczna Alokacja
            elif text.lower().find('stabilny wzrost') != -1:
                return 7003 #UniStabilny Wzrost
            elif text.lower().find('korona zr') != -1:
                return 8003 #UniKorona Zrownowazony
            elif text.lower().find('akcje: nowa') != -1:
                return 9003 #UniAkcje: Nowa Europa
            elif text.lower().find('korona akcje') != -1:
                return 10003 #UniKorona Akcje
            elif text.lower().find('sektory wzrostu') != -1:
                return 11003 #UniAkcje Sektory Wzrostu
            elif text.lower().find('total trend') != -1:
                return 12003 #UniTotal Trend Subfundusz SFIO
            elif text.lower().find('akcje ma') != -1:
                return 13003 #UniAkcje Malych i Srednich Spolek
            elif text.lower().find('obligacje aktywny') != -1:
                return 14003 #UniObligacje Aktywny Subfundusz SFIO
            else:
                return 3#inne uni
        elif text.lower().find('allianz') != -1:
            if text.lower().find('selektywny') != -1:
                return 1004 #Allianz Selektywny
            elif text.lower().find('ich obligacji ska') != -1:
                return 2004 #Allianz Polskich Obligacji Skarbowych
            elif text.lower().find('wnej alokacji') != -1:
                return 3004 #Allianz Aktywnej Alokacji
            elif text.lower().find('pieni') != -1:
                return 4004 #Allianz Pieniezny
            elif text.lower().find('obligacji plus') != -1:
                return 5004 #Allianz Obligacji Plus
            elif text.lower().find('lnego wzrostu') != -1:
                return 6004 #Allianz Stabilnego Wzrostu
            elif text.lower().find('akcji plus') != -1:
                return 7004 #Allianz Akcji Plus
            elif text.lower().find('akcji') != -1:
                if text.lower().find('akcji plus') != -1:
                    return 7004 #
                elif text.lower().find('akcji ma') != -1:
                    return 9004 #
                else:
                    return 8004 #Allianz Akcji
            elif text.lower().find('akcji ma') != -1:
                return 9004 #Allianz Akcji Malych i Srednich Spolek
            else:
                return 4#inne allianz
        elif text.lower().find('skarbiec') != -1:
            if text.lower().find('depozytowy') != -1:
                return 1005 #SKARBIEC - depozytowy
            elif text.lower().find('obligacja') != -1:
                return 2005 #SKARBIEC - obligacja
            elif text.lower().find('kasa') != -1:
                return 3005 #SKARBIEC - kasa
            elif text.lower().find('ochrony kapit') != -1:
                return 4005 #SKARBIEC Ochrony Kapitalu
            elif text.lower().find('alternatywny') != -1:
                return 5005 #Skarbiec-Alternatywny SFIO
            elif text.lower().find('iii filar') != -1:
                return 6005 #SKARBIEC - III FILAR
            elif text.lower().find('zagranicznych') != -1:
                return 7005 #SKARBIEC-TOP Funduszy Zagranicznych
            elif text.lower().find('alokacji globalnej') != -1:
                return 8005 #SKARBIEC - alokacji globalnej
            elif text.lower().find('waga') != -1:
                return 9005 #SKARBIEC - waga
            elif text.lower().find('w surowcowych') != -1:
                return 10005 #SKARBIEC - Rynkow Surowcowych
            elif text.lower().find('akcji nowej') != -1:
                return 11005 #SKARBIEC - Akcji Nowej Europy
            elif text.lower().find('akcja') != -1:
                return 12005 #SKARBIEC - akcja
            elif text.lower().find('wzrostowych') != -1:
                return 13005 #SKARBIEC - Spolek Wzrostowych
            elif text.lower().find('aktywnej alo') != -1:
                return 14005 #SKARBIEC - aktywnej alokacji
            elif text.lower().find('selektywny nowej') != -1:
                return 15005 #SKARBIEC - Selektywny Nowej Europy
            elif text.lower().find('rednich sp') != -1:
                return 16005 #SKARBIEC-Malych i Srednich Spolek
            elif text.lower().find('lokacyjny') != -1:
                return 17005 #Skarbiec-Lokacyjny
            else:
                return 5
        elif text.lower().find('legg') != -1:
            if text.lower().find('obligacji') != -1:
                return 1006 #LEGG MASON OBLIGACJI FIO
            elif text.lower().find('pieni') != -1:
                return 2006 #LEGG MASON PIENIEZNY
            elif text.lower().find('senior') != -1:
                return 3006 #LEGG MASON SENIOR SFIO
            elif text.lower().find('akcji') != -1:
                return 4006 #LEGG MASON AKCJI FIO
            elif text.lower().find('strateg') != -1:
                return 5006 #LEGG MASON STRATEG FIO
            else:
                return 6
        if text.lower().find('investor') != -1:
            if text.lower().find('gold') != -1:
                return 1007 #Investor Gold Otwarty
            elif text.lower().find('obligacji') != -1:
                return 2007 #Investor Obligacji FIO
            elif text.lower().find('ynna lokata') != -1:
                return 3007 #Investor Plynna Lokata FIO
            elif text.lower().find('wkowy') != -1:
                return 4007 #Investor Gotowkowy
            elif text.lower().find('ameryka') != -1:
                return 5007 #Investor Ameryka Lacinska
            elif text.lower().find('w wschodz') != -1:
                return 6007 #Investor Zrownowazony Rynkow Wschodzacych
            elif text.lower().find('indie i ch') != -1:
                return 7007 #Investor Indie i Chiny
            elif text.lower().find('enia emeryt') != -1:
                return 8007 #Investor Zabezpieczenia Emerytalnego FIO
            elif text.lower().find('rosja') != -1:
                return 9007 #Investor Rosja
            elif text.lower().find('agrobiznes') != -1:
                return 10007 #Investor Agrobiznes
            elif text.lower().find('wnowa') != -1:
                if text.lower().find('w wschodz') != -1:
                    return 6007 #
                else:
                    return 11007 #Investor Zrownowazony FIO
            elif text.lower().find('bric') != -1:
                return 12007 #Investor BRIC
            elif text.lower().find('akcji du') != -1:
                return 13007 #Investor Akcji Duzych Spolek FIO
            elif text.lower().find('turcja') != -1:
                return 14007 #Investor Turcja
            elif text.lower().find('zmian klim') != -1:
                return 15007 #Investor Zmian Klimatycznych
            elif text.lower().find('akcji') != -1:
                if text.lower().find('akcji du') != -1:
                    return 13007 #
                else:
                    return 16007 #Investor Akcji FIO
            elif text.lower().find('nieru') != -1:
                return 17007 #Investor Nieruchomosci i Budownictwa
            elif text.lower().find('top 50') != -1:
                return 18007 #Investor Top 50 Malych i Srednich Spolek FIO
            elif text.lower().find('top 25') != -1:
                return 19007 #Investor Top 25 Malych Spolek FIO
            elif text.lower().find('infras') != -1:
                return 20007 #Investor Infrastruktury i Informatyki
            else:
                return 7
        elif text.lower().find('bph') != -1:
            if text.lower().find('skarbowy') != -1:
                return 1008 #BPH Subfundusz Skarbowy
            elif text.lower().find('obligacji europ') != -1:
                return 2008 #BPH Subfundusz Obligacji Europy Wschodzacej
            elif text.lower().find('obligacji 1') != -1:
                return 3008 #BPH Subfundusz Obligacji 1
            elif text.lower().find('akcji globalny') != -1:
                return 4008 #BPH Subfundusz Akcji Globalny
            elif text.lower().find('obligacji 2') != -1:
                return 5008 #BPH Subfundusz Obligacji 2
            elif text.lower().find('selektywny') != -1:
                return 6008 #BPH Subfundusz Selektywny
            elif text.lower().find('lnego wzr') != -1:
                return 7008 #BPH Subfundusz Stabilnego Wzrostu
            elif text.lower().find('aktywnego zarz') != -1:
                return 8008 #BPH Subfundusz Aktywnego Zarzadzania
            elif text.lower().find('ci i surow') != -1:
                return 9008 #BPH Subf Globalny Zywnosci i Surowcow
            elif text.lower().find('total profit') != -1:
                return 10008 #BPH SFIO Total Profit
            elif text.lower().find('akcji europy ws') != -1:
                return 11008 #BPH Subfundusz Akcji Europy Wschodzacej
            elif text.lower().find('akcji') != -1:
                if text.lower().find('europy') != -1:
                    return 11008 #
                elif text.lower().find('dynamicz') != -1:
                    return 13008 # BPH Subfundusz Akcji Dynamicznych Spolek
                else:
                    return 12008 #BPH Subfundusz Akcji
            elif text.lower().find('niruch') != -1:
                return 14008 #BPH Subfundusz Nieruchomosci Europy Wschodzacej
            else:
                return 8 #
        else:
            return 0

class Fund():
    def __init__(self, name):
        self.name = name
        self.refresh()
    def refresh(self):
        self.getdate()
        self.getprice()
                      
class Waluta(Fund):
    codding = 'utf-8'
    def getdate(self):
        a = urlopen('http://www.mbank.pl/przewodnik/kurs_walut/')
        for line in a:
            if 'Tabela kursowa obowiazuje od dnia ' in line:
                i = line.find('Tabela kursowa obowiazuje od dnia ')
                l = len('Tabela kursowa obowiazuje od dnia ')
                i += l
                self.date = date(int(line[i+6:i+10]),int(line[i+3:i+5]),int(line[i+0:i+2]))
                return self.date
        self.date = "Couldn't find"
        
    def getprice(self):
        a = urlopen('http://www.mbank.pl/przewodnik/kurs_walut/')
        for line in a:
            if self.name + '</td>' in line:
                b = a.next()
                i = b.find('">')
                k = b.find("</td>")
                i += 2
                self.price = decimal.Decimal(b[i:k].replace(',','.'))
                return self.price
        self.price = "Couldn't find"

class SFI(Fund):
    def getdate(self):
        a = urlopen('http://www.mbank.pl/bin/sfi/sfi_do_csv.php?&date=2012-02-03&show=all')
        for line in a:
            if self.name in line:
                for i in range(11): a.next()
                b = a.next()
                self.date = date(int(b[13:15])+2000,int(b[16:18]),int(b[19:21]))
                return self.date
        self.date = "Couldn't find"
        
    def getprice(self):
        a = urlopen('http://www.mbank.pl/indywidualny/inwestycje/sfi/notowania/tab3.pl')
        for line in a:
            if self.name in line:
                a.next()
                b = a.next()
                f = '<td class="ar">'
                self.price = decimal.Decimal(b[b.find(f)+len(f):b.find('</td>')].replace(',','.'))
                return self.price
        self.price = "Couldn't find"
        
class RBSCBG(Fund):
    def getdate(self):
        a = urlopen('http://funds.ft.com/royalbankofscotland/collectiveinvestment/UYBGA')
        b = '<span id="ctl00_ContentWell_ListPriceInformation_lblLatestPriceDate">'
        for line in a:
            if b in line:
                self.date = date(
                int(line[line.find(b)+len(b)+6:line.find(b)+len(b)+10]),
                int(line[line.find(b)+len(b)+3:line.find(b)+len(b)+5]),
                int(line[line.find(b)+len(b)+0:line.find(b)+len(b)+2]))
                return self.date
        self.date = "Couldn't find"
        
    def getprice(self):
        a = urlopen('http://funds.ft.com/royalbankofscotland/collectiveinvestment/UYBGA')
        b = '<span id="ctl00_ContentWell_ListPriceInformation_lblLatestPrice">'
        for line in a:
            if b in line:
                self.price = decimal.Decimal(line[line.find(b)+len(b):line.find('</span>')].replace(',','.'))
                return self.price
        self.price = "Couldn't find"

        
class Arka(Fund):
    def getdate(self):
        a = urlopen('http://arka.pl/fundusze/pl/minitab_all.html')
        for line in a:
            if 'onclick="changeday' in line:
                b = line[line.find('</div><div class="menu"')-10:line.find('</div><div class="menu"')]
                self.date = date(int(b[6:]),int(b[3:5]),int(b[0:2]))
                return self.date
        self.date = "Couldn't find"
        
    def getprice(self):
        a = urlopen('http://arka.pl/fundusze/pl/minitab_all.html')
        n = (self.name).replace('Arka ','').replace(' ', '&nbsp;')
        
        for line in a:
            if ('_parent">' + n + '</a></td>') in line:
                b = a.next()
                f = '"text-align: right;">'
                self.price = decimal.Decimal(b[b.find(f)+len(f):b.find('</div>')].replace(',','.'))
                return self.price
        self.price = "Couldn't find"
